---
title: Tutorials and code examples of SOLIDWORKS eDrawings API
caption: eDrawings API
description: Overview of SOLIDWORKS eDrawings API, examples, tutorials and code snippets
image: edrawings-api.svg
labels: [edrawings]
---
![eDrawings API](edrawings-api.svg){ width=350 }

eDrawings is a stand-alone application developed by SOLIDWORKS which allows to view and markup SOLIDWORKS files, some foreign files and lightweight eDrawings format. Free version is available along with Professional version.

In addition to specific eDrawings files format (*.eprt, *.easm, *.edrw), eDrawings can import files from several popular CAD systems, such as SOLIDWORKS (*.sldprt, *.sldasm, *.slddrw), Autodesk Inventor (*.ipt, *.iam), CATIA (*.catpart, .catproduct), Solid Edge (*.par, *.psm, *.asm), Pro/Engineer (*.asm, *.prt), NX (*.prt) etc. as well as neutral CAD formats, such as STEP, IGES, SAT, etc.

eDrawings can export files to Web Html Files (*.html), Stereolithography Files (*.stl), Image Files (*.bmp, *.tif, *.jpg, *.png, *.gif) etc.

eDrawings also supports printing from drawing documents. 

eDrawings viewer is lightweight and doesn't require to have SOLIDWORKS installed to view files. Download eDrawings from the [eDrawings Viewer](https://www.edrawingsviewer.com) web-site.

[API help](https://help.solidworks.com/2016/english/api/SWHelp_List.html?id=910f478a27674aea9e7869b31a3f9252) is available online.
