---
title: Managing e-mails for custom domains
caption: E-Mail
description: Guides for setting up and managing e-mails for custom domains (e.g. configuring forwarding of e-mails or using hosted options)
labels: [e-mail,email forwarding]
---
## Configuring E-mail forwarding

If you are owning the domain name in the registrar such as GoDaddy or Google Domains, you might want to use e-mails with this domain name to send and receive messages (e.g. info@mydomain.com). Using the custom domain name provides better professional look for your e-mails instead of using free services (e.g. mydomaininfo@gmail.com).

Majority of registrars provide options to host e-mails with custom domains, but in most cases those options are not free and price varies from several dollars to dozens of dollars per month per e-mail depending on the usage, space and support arrangements.

However most of the registrars provide free e-mail forwarding service for dozens or hundreds of e-mails. So you can still use your favourite e-mail service (including free services such as Gmail or Outlook) to host your e-mails, but use forwarding and e-mail aliases to customize the address of your e-mail to have a custom domain name.

Below video demonstrates how to setup the e-mail forwarding and alias using Gmail and domain name hosted on GoDaddy.

{% youtube { id: rqOOnlTUuAw } %}

1. [Setup GoDaddy E-Mail Forwarding](godaddy-email-forwarding). As described in the video e-mails forwarded by GoDaddy from *secureserver.net* (Step 1) are not encrypted which results in the warning and vulnerability. To overcome this limitation, skip this step and go to step 2, otherwise proceed to step 4.
1. [Transfer GoDaddy Domain To Google Domains](transfer-godaddy-domain-to-googledomains)
1. [Setup Google Domains E-Mail Forwarding](googledomains-email-forwarding)
1. [Setup E-Mail Aliases In Gmail](setup-gmail-email-aliases)