---
caption: Source Code
title: Managing source code
description: Storing and managing source code
---
Version control is a vital part of any code development. This enables simple ways to track changes as well as enables the collaboration between developers.

There are multiple version control (CVS) systems available, this includes but not limited to:

* [GIT](https://git-scm.com/)
* [Subversion](https://subversion.apache.org/)
* [Mercurial](https://www.mercurial-scm.org/)

Although it is not a requirement, it is strongly recommended to host the source code in the repository. 

Repository server can be setup on the local server or in the available cloud providers: [GitHub](https://github.com/), [Bit Bucket](https://bitbucket.org/), [Git Lab](https://about.gitlab.com/), [AWS Code Commit](https://aws.amazon.com/codecommit/), [Azure Repos](https://azure.microsoft.com/en-au/services/devops/repos/) etc.

Some of the above providers have free tier.

Having the source code stored on the cloud server not only simplifies the access, sharing, version history but also enables additional levels of security, backup options, etc.
