---
title: SwEx - framework which simplifies the development using SOLIDWORKS API
caption: SwEx
description: Libraries for extending SOLIDWORKS functionality and utilizing API
image: logo.png
categories: sw-labs
group: For Developers
toc-group-name: labs-solidworks-swex
type: sw-lab
---
![SwEx Framework](logo.png)

SwEx (SOLIDWORKS Extra or SOLIDWORKS Extended) is a framework which is designed to simplify development of software for SOLIDWORKS in .NET (C# and VB.NET).

Framework provides utilities for implementation software design principles such as [S.O.L.I.D](https://en.wikipedia.org/wiki/SOLID) for developing maintainable and scalable solutions for SOLIDWORKS.

There are 3 main section of SOLIDWORKS API functionality which are covered by framework

* [Add-In](add-in) - add-in skeleton, commands, menus, toolbars, events management, data access
* [Property Manager Pages](pmpage) - building native property manager pages with data binding
* [Macro Feature](macro-feature) - building parametric native features

Framework source code is available on GitHub.

* [SwEx.AddIn](https://github.com/codestackdev/swex-addin)
* [SwEx.PMPage](https://github.com/codestackdev/swex-pmpage)
* [SwEx.MacroFeature](https://github.com/codestackdev/swex-macrofeature)