---
title: SwEx.PMPage - advanced framework for SOLIDWORKS property manager pages
caption: SwEx.PMPage
description: Utilities for advanced development of SOLIDWORKS Property Manager Pages which enables data driven development with data binding
toc-group-name: labs-solidworks-swex
order: 3
redirect-from:
  - /labs/solidworks/vpages/
  - /labs/solidworks/swex/pmp/
---
![SwEx.PMPage framework for SOLIDWORKS](logo.png)

Inspired by [PropertyGrid Control](https://msdn.microsoft.com/en-us/library/aa302326.aspx) in .NET Framework, SwEx.PMPage brings the flexibility of data model driven User Interface into SOLIDWORKS API.

Framework allows to use data model structure as a driver of the User Interface. Framework will automatically generate required interface and implement the binding of the model.

This will greatly reduce the implementation time as well as make the property pages scalable, easily maintainable and extendable.

## Video Tutorials

### Introduction

{% youtube { id: V6mBpvp_J9U } %}

### Detailed Guide

{% youtube { id: wFAHCo1_gD0 } %}