---
title: Adding graphical elements to model graphics view using SOLIDWORKS API
caption: Adornment
description: Collection of articles and code examples which explain the different ways of customizing the view of the model and application (callouts, open GL graphics, etc.)
image: adornment-api.png
order: 6
---
![SOLIDWORKS API for adornment of models and application](adornment-api.png)

This section contains the articles and code examples which explain the different ways of customizing the view of the SOLIDWORKS model and application frame using API.

This includes, but not limited to

* Adding [callout](/solidworks-api/adornment/callouts/) objects. Those objects can be useful to display additional information, such as tags or properties for the specific entities. Callouts also supports data value entry.
* Injecting custom 3D graphics to the model view via Open GL. This can be useful when it is required to render complex graphics directly in the SOLIDWORKS model without modifying its geometry. The most common usage scenario is preview or Finite Elements Analysis (FEA) rendering.
* Adding 2D images on the graphics view
* Embedding [OLE objects](solidworks-api/adornment/ole-objects/) into the model
