---
title: SOLIDWORKS PDM Professional API
caption: PDM Professional (EPDM) API
description: Overview of SOLIDWORKS PDM Professional (formerly SOLIDWORKS EPDM) API, examples, tutorials and code snippets
image: solidworks-pdm-api.svg
labels: [epdm]
---
![SOLIDWORKS PDM API](solidworks-pdm-api.svg){ width=250 }

SOLIDWORKS PDM Professional (formerly SOLIDWORKS EPDM) is Product Data Management system allowing to manage the life cycle of CAD documents.

Main feature include:

* Centralized vault for securing data files
* Data card for managing metadata
* Workflows management
* User access management
* Bill of materials management
* Concurrent file access management
* Integration with SOLIDWORKS and other CAD systems, such as AutoCAD, Solid Edge, ProE etc.

SOLIDWORKS PDM is a highly configurable system which can be customized for a specific business process.

SOLIDWORKS PDM API enables an access to a large number of API interfaces providing the possibility to extend the PDM functionality. This includes, but not limited to:

* Creating automation tasks add-ins with an ability to execute on a remote server
* Creating serial number add-ins
* Handling various events via SOLIDWORKS PDM hooks: file check in/check out, workflow change, etc.
* Extending the menus and toolbars

This section contains tutorials, code examples and snippets for the most common SOLIDWORKS PDM API functionality.
